#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include <sys/utsname.h>
#include <sys/ioctl.h>
#include <string.h>
#include <fcntl.h>
#include <stdarg.h>
#include <libnet.h>
#include <unistd.h>
#include "config.h"

#define MAXSIZE 4069

int icmpraw(char *d_ip, char *s_ip, int type) {

  extern int timeout;
  int network;
  int numread;
  int packet_size = 0, c;
  u_long src_ip, dst_ip;
  u_char *packet;
  char buf[MAXSIZE];
  struct icmphdr *icmp;
  struct timeval tv;
  fd_set fds;

  src_ip = 0;
  dst_ip = 0;

  if (!(dst_ip = libnet_name_resolve (d_ip, LIBNET_RESOLVE)))
    {
      libnet_error (LIBNET_ERR_FATAL, "Bad destination IP address: %s\n",
		    d_ip);
    }
  if (!(src_ip = libnet_name_resolve (s_ip, LIBNET_RESOLVE)))
    {
      libnet_error (LIBNET_ERR_FATAL, "Bad source IP address: %s\n", s_ip);
    }

  packet_size = LIBNET_IP_H + LIBNET_ICMP_ECHO_H;

  libnet_init_packet (packet_size, &packet);
  if (packet == NULL)
    libnet_error (LIBNET_ERR_FATAL, "libnet_init_packet failed\n");


  if ((network = libnet_open_raw_sock (IPPROTO_ICMP)) == -1)
    libnet_error (LIBNET_ERR_FATAL, "Can't open network.\n");



  FD_ZERO(&fds);
  FD_SET(network,&fds);
  tv.tv_sec = timeout;
  tv.tv_usec = 0;


  libnet_build_ip (ICMP_ECHO_H,	 /* size */
		   0,		/* tos */
		   randp(),	/* id */
		   0,		/* frag */
		   255,		/* ttl */
		   IPPROTO_ICMP,/* protocol */
		   src_ip,	/* source ip */
		   dst_ip,	/* destination ip */
		   NULL,	/* payload */
		   0,		/* payload */
		   packet);	/* packet header memory */



  libnet_build_icmp_echo (ICMP_ECHO,              /* Type */
		          0, 		          /* Code */
		          randp(),                /* id */
		          htons(randp()),         /* seq*/
		    	  NULL,	                  /* payload */
		   	  0,	                  /* payload size */
		          packet + LIBNET_IP_H);  /* packet header memory */



  if (libnet_do_checksum (packet, IPPROTO_ICMP, LIBNET_ICMP_ECHO_H) == -1)
    libnet_error (LIBNET_ERR_FATAL, "libnet_do_checksum failed\n");


  if ((c = libnet_write_ip (network, packet, packet_size)) < packet_size)
    return 0;

  libnet_destroy_packet (&packet);


#ifdef LOCAL

 if((select(network+1,&fds,NULL,NULL,&tv)) > 0) {

  if ((numread = read (network, buf, MAXSIZE)) < 0)
    return -1; }

 else
  return -1;

#endif 

 if((select(network+1,&fds,NULL,NULL,&tv)) > 0) {
  if ((numread = read (network, buf, MAXSIZE)) < 0)
    return -1; }
 else
  return -1;



 if ((buf[0] >> 4) != 4)       /* Ip? */
    return -1;

  if (buf[9] != 1)
    return -1;


  icmp = (struct icmphdr *)&buf[20];

  if (libnet_close_raw_sock (network) == -1)
    libnet_error (LN_ERR_WARNING,
		  "libnet_close_raw_sock couldn't close the interface");

  if((!icmp->code) && (!icmp->type))
  return ICMPECHO;


  return -1;

}
