#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <libnet.h>
#include <sys/wait.h>
#include <sys/types.h>
#include "config.h"

extern char *optarg;
int timeout = 5;
int delay = 0;

int
main (int argc, char *argv[])
{

  int optval;
  char *optopt = "C:l:s:c:d:t:p:P:DTSAKFNXREIO";

  char *dst_ip = NULL;
  char *src_ip = NULL;
  char *listfile = NULL;
  char buf[64];

  unsigned int dst_port = 0;
  unsigned int src_port = 0;

  int sp = 0, dp = 0;
  int send = 1, count;
  int decoy = 0;

  extern int timeout;
  extern int delay; 
  u_char flag = 0;
  FILE *fp = NULL;

  if (argc < 2)
    use (argv[0]);

  while ((optval = getopt (argc, argv, optopt)) != EOF)
    {

      switch (optval)
	{

	case 's':
	  {
	    src_ip = optarg;
	    break;
	  }

	case 'd':
	  {
	    dst_ip = optarg;
	    break;
	  }

	case 'p':
	  {
	    dp = 1;
	    dst_port = atoi (optarg);
	    break;
	  }

	case 'P':
	  {
	    sp = 1;
	    src_port = atoi (optarg);
	    break;
	  }

	case 't':
	  {
	    timeout = atoi (optarg);
	    break;
	  }

	case 'l':
	  {
	    listfile = optarg;
	    break;
	  }

	case 'D':
	  {
	    delay = 1;
	    break;
	  }

	case 'c':
	  {
	    send = atoi (optarg);
	    break;
	  }

	case 'C':
	  {
	    decoy = atoi (optarg);
	    break;
	  }

	case 'T':
	  {
	    probeopt.tcp = 1;
	    break;
	  }

		case 'S':
	  	{
	    	 probeopt.tcp_syn = 1;
	    	 break;
	  	}

		case 'A':
	  	{
	    	 probeopt.tcp_ack = 1;
	    	 break;
	  	}

		case 'K':
	  	{
	    	 probeopt.tcp_synack = 1;
	    	 break;
	  	}

		case 'F':
	  	{
	    	 probeopt.tcp_fin = 1;
	   	 break;
	  	}

		case 'N':
	  	{
	    	 probeopt.tcp_null = 1;
	    	 break;
	  	}

		case 'X':
	  	{
	    	 probeopt.tcp_xmass = 1;
	    	 break;
	  	}

		case 'R':
                {
		 probeopt.tcp_syn = 1;
		 probeopt.tcp_ack = 1;
		 probeopt.tcp_synack = 1;
		 probeopt.tcp_fin = 1;
		 probeopt.tcp_null = 1;
		 probeopt.tcp_xmass = 1;
		 break;
                }   

	case 'O':
	 {
	   probeopt.other = 1;
	   break; 
         }

		case 'E':
		 {
		  probeopt.icmp_echo = 1;
		  break; 
                 }

	}
    }


  printf ("Mapper - Host conectivity tester\n");
  printf ("Phish@mindless.com\n\n");

  if (src_ip == NULL || (dst_ip == NULL && listfile == NULL))
    {
      printf ("Error: a destination and source ip must be provided\n");
      exit (1);
    }

  if (listfile != NULL)
    {
      if ((fp = fopen (listfile, "r")) == NULL)
	{
	  perror ("fopen()");
	  exit (1);
	}
    }


top:;				/* Ugly hack to make lists work */

  if (listfile != NULL)
    {
      if ((fgets (buf, sizeof (buf), fp)) == NULL)
	{
	  listfile = NULL;
	  fclose (fp);
	  return 0;
	}

      dst_ip = strtok (buf, "\n");

    }

  for (count = 0; count < send; count++)
    {
      if (!sp)
	src_port = randp ();
      if (!dp)
	dst_port = randp ();

      if (delay)
	usleep (randp()*(randp()/2000));

      if (probeopt.tcp)
	{			/* Tcp pings */


	  if (probeopt.tcp_syn)
	    {

	      printf ("%s: ", dst_ip);
	      printf ("Syn -><- ");

               if (delay)
	        usleep (randp()*(randp()/2000));

	      if (decoy)
		tdecoy (dst_ip, dst_port, decoy, TH_SYN);

	      flag = tcpraw (dst_ip, src_ip, dst_port, src_port, TH_SYN);
	      printf ("%s", flag_trans (flag));

	  	if (flag > 1)
	      	  printf (" * alive\n");
	  	else if (flag == 1)
	    	  printf (" * dead\n");
	  	else
	          printf (" * error\n");
             }

	  if (probeopt.tcp_ack)
	    {

	      printf ("%s: ", dst_ip);
	      printf ("Ack -><- ");

               if (delay)
	        usleep (randp()*(randp()/2000));

	      if (decoy)
		tdecoy (dst_ip, dst_port, decoy, TH_ACK);

	      flag = tcpraw (dst_ip, src_ip, dst_port, src_port, TH_ACK);
	      printf ("%s", flag_trans (flag));

	  	if (flag > 1)
	      	  printf (" * alive\n");
	  	else if (flag == 1)
	    	  printf (" * dead\n");
	  	else
	          printf (" * error\n");
	    }

	  if (probeopt.tcp_synack)
	    {

	      printf ("%s: ", dst_ip);
	      printf ("SynAck -><- ");

               if (delay)
	        usleep (randp()*(randp()/2000));

	      if (decoy)
		tdecoy (dst_ip, dst_port, decoy, (TH_SYN ^ TH_ACK));

	      flag =
		tcpraw (dst_ip, src_ip, dst_port, src_port, TH_SYN ^ TH_ACK);
	      printf ("%s", flag_trans (flag));

	  	if (flag > 1)
	      	  printf (" * alive\n");
	  	else if (flag == 1)
	    	  printf (" * dead\n");
	  	else
	          printf (" * error\n");
	    }

	  if (probeopt.tcp_fin)
	    {

	      printf ("%s: ", dst_ip);
	      printf ("Fin -><- ");

               if (delay)
	        usleep (randp()*(randp()/2000));

	      if (decoy)
		tdecoy (dst_ip, dst_port, decoy, TH_FIN);

	      flag = tcpraw (dst_ip, src_ip, dst_port, src_port, TH_FIN);
	      printf ("%s", flag_trans (flag));

	  	if (flag > 1)
	      	  printf (" * alive\n");
	  	else if (flag == 1)
	    	  printf (" * dead\n");
	  	else
	          printf (" * error\n");
	    }

	  if (probeopt.tcp_null)
	    {

	      printf ("%s: ", dst_ip);
	      printf ("Null -><- ");

               if (delay)
	        usleep (randp()*(randp()/2000));

	      if (decoy)
		tdecoy (dst_ip, dst_port, decoy, 0);

	      flag = tcpraw (dst_ip, src_ip, dst_port, src_port, 0);
	      printf ("%s", flag_trans (flag));

	  	if (flag > 1)
	      	  printf (" * alive\n");
	  	else if (flag == 1)
	    	  printf (" * dead\n");
	  	else
	          printf (" * error\n");
	    }

	  if (probeopt.tcp_xmass)
	    {

	      printf ("%s: ", dst_ip);
	      printf ("Xmas -><- ");

               if (delay)
	        usleep (randp()*(randp()/2000));

	      if (decoy)
		tdecoy (dst_ip, dst_port, decoy,
			(TH_SYN ^ TH_ACK ^ TH_FIN ^ TH_PUSH ^ TH_URG));

	      flag = tcpraw (dst_ip, src_ip, dst_port, src_port, TH_SYN ^
			     TH_ACK ^ TH_FIN ^ TH_PUSH ^ TH_URG);
	      printf ("%s", flag_trans (flag));

	  	if (flag > 1)
	      	  printf (" * alive\n");
	  	else if (flag == 1)
	    	  printf (" * dead\n");
	  	else
	          printf (" * error\n");
	    }


	}			/* end of tcp */

	if(probeopt.other) 
         {

	   if(probeopt.icmp_echo) {

		printf("%s: ",dst_ip);
		printf("Echo -><- ");

		 if(delay)
		  usleep(randp()*(randp()/2000));

		 if(decoy)
		   idecoy(dst_ip,ICMPECHO,decoy);

		if((icmpraw(dst_ip,src_ip,ICMPECHO)) == ICMPECHO)
		printf("Echo Reply * alive\n");
		else
		printf("(null) * dead\n");

             }
           }			/* end of icmp */

         }		/* end of for */


  if (listfile != NULL)
    {
      printf ("\n");
      goto top;
    }


  return 0;

}
