#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include <sys/utsname.h>
#include <sys/ioctl.h>
#include <string.h>
#include <fcntl.h>
#include <stdarg.h>
#include <libnet.h>
#include <unistd.h>
#include "config.h"

#define MAXSIZE 4069

u_char
tcpraw (char *d_ip, char *s_ip, unsigned int dst_prt, unsigned int src_prt,
	u_char control)
{

  extern int timeout;
  int network;
  int numread;
  int packet_size, c;
  u_long src_ip, dst_ip;
  u_char *packet;
  char buf[MAXSIZE];
  struct tcphdr *tcp;
  struct timeval tv;
  fd_set fds;

  src_ip = 0;
  dst_ip = 0;

  if (!(dst_ip = libnet_name_resolve (d_ip, LIBNET_RESOLVE)))
    {
      libnet_error (LIBNET_ERR_FATAL, "Bad destination IP address: %s\n",
		    d_ip);
    }
  if (!(src_ip = libnet_name_resolve (s_ip, LIBNET_RESOLVE)))
    {
      libnet_error (LIBNET_ERR_FATAL, "Bad source IP address: %s\n", s_ip);
    }


  packet_size = LIBNET_IP_H + LIBNET_TCP_H;

  libnet_init_packet (packet_size, &packet);
  if (packet == NULL)
    libnet_error (LIBNET_ERR_FATAL, "libnet_init_packet failed\n");


  if ((network = libnet_open_raw_sock (IPPROTO_TCP)) == -1)
    libnet_error (LIBNET_ERR_FATAL, "Can't open network.\n");



  FD_ZERO(&fds);
  FD_SET(network,&fds);
  tv.tv_sec = timeout;
  tv.tv_usec = 0;


  libnet_build_ip (LIBNET_TCP_H,/* size */
		   0,		/* tos */
		   randp(),	/* id */
		   0,		/* frag */
		   255,		/* ttl */
		   IPPROTO_TCP,	/* protocol */
		   src_ip,	/* source ip */
		   dst_ip,	/* destination ip */
		   NULL,	/* payload */
		   0,		/* payload */
		   packet);	/* packet header memory */

  libnet_build_tcp (src_prt,	   /* source TCP port */
		    dst_prt,	   /* destination TCP port */
		    htons(rand()), /* sequence number */
		    htons(rand()), /* acknowledgement number */
		    control,	   /* control flags */
		    1024,	   /* window size */
		    0,		   /* urgent pointer */
		    NULL,	   /* payload (none) */
		    0,		   /* payload length */
		    packet + LIBNET_IP_H);	/* packet header memory */


  if (libnet_do_checksum (packet, IPPROTO_TCP, LIBNET_TCP_H) == -1)
    libnet_error (LIBNET_ERR_FATAL, "libnet_do_checksum failed\n");


  if ((c = libnet_write_ip (network, packet, packet_size)) < packet_size)
    return 0;

  libnet_destroy_packet (&packet);
  /* Recving reply */

#ifdef LOCAL

 if((select(network+1,&fds,NULL,NULL,&tv)) > 0) {
  if ((numread = read (network, buf, MAXSIZE)) < 0)
    return 1; }
 else
  return 1;
#endif /* LOCAL */

 if((select(network+1,&fds,NULL,NULL,&tv)) > 0) {
  if ((numread = read (network, buf, MAXSIZE)) < 0)
    return 1; }
 else
  return 1;

  if ((buf[0] >> 4) != 4)	/* Ip? */
    return -1;

  /* Tcp? */
  if (buf[9] != 6)
    return -1;

  tcp = (struct tcphdr *) &buf[20];

  if (libnet_close_raw_sock (network) == -1)
    libnet_error (LN_ERR_WARNING,
		  "libnet_close_raw_sock couldn't close the interface");

  return tcp->th_flags;

}
